//
// Revalation - a simple yet flexible relational database
// Copyright (C) 2000 Mark Rigby-Jones <mrj@compsoc.net>
// http://www.compsoc.net/~mrj/palm/revalation/
// 
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//

#include <Pilot.h>
#include "revalation.h"
#include "revalationRsc.h"

/****************************************************************************
 *									    *
 *  Field List Dialog Box						    *
 *									    *
 ****************************************************************************/

void FormFldListPopup(void) {
    FormPtr		frm;
    FormPtr		oldfrm;
    TablePtr		tbl;
    UInt		button;
    Short		i;

    frm = FrmInitForm(FormFldList);
    oldfrm = FrmGetActiveForm();
	
    FrmSetEventHandler(frm, FormFldListHandleEvent);
    FrmSetActiveForm(frm);

    GetFieldList();
    
    tbl = FrmGetObjectPtr(frm, FrmGetObjectIndex(frm, TableFldListFields));
    //TblSetColumnUsable(tbl, 0, true);
    //TblSetColumnUsable(tbl, 1, true);
    for (i = 0; i < 11; i++) {
	//TblSetItemStyle(tbl, i, 0, textTableItem);
	//TblSetItemStyle(tbl, i, 1, popupTriggerTableItem);
	if (i < count) {
	    // TODO
	}
    }
    TblHasScrollBar(tbl, true);
    value = 0;

    ScrollBarFldListFieldsSet(frm);
    TblDrawTable(tbl);

    button = FrmDoDialog(frm);

    FreeFieldList();
    
    FrmSetActiveForm(oldfrm);
    FrmDeleteForm(frm);
    
    if (button == ButtonFldListOK) {
	// TODO something!
    }
}

Boolean FormFldListHandleEvent(EventPtr e) {
    Boolean		handled = false;
    FormPtr		frm;
    TablePtr		tbl;
    //CharPtr		ptr;
    //Short		i;
    Short		oldvalue;
    //Err			error;
    
    switch (e->eType) {
	case menuEvent:
	    MenuEraseStatus(NULL);

	    switch(e->data.menu.itemID) {
	    }

	    handled = true;
	    break;
	
	case sclRepeatEvent:
	    frm = FrmGetActiveForm();
	    tbl = FrmGetObjectPtr(frm,
		    FrmGetObjectIndex(frm, TableFldListFields));
	    
	    value = e->data.sclRepeat.newValue;
	    TblDrawTable(tbl);
	    break;
	
	case ctlSelectEvent:
	    switch(e->data.ctlSelect.controlID) {
		case ButtonRecListDone:
		    FrmGotoForm(FormTblList);
		    break;
		case ButtonRecListNew:
		    record = -1;
		    FrmGotoForm(FormRecord);
		    break;
	    }
	    break;

	case keyDownEvent:
	    oldvalue = value;

    	    switch(e->data.keyDown.chr) {
		case pageUpChr:
		    if (value < 11) {
			value = 0;
		    } else {
			value -= 10;
		    }
		    break;
		case pageDownChr:
		    if (value > (count - 22)) {
			value = count - 11;
		    } else {
			value += 10;
		    }
		    break;
	    }

	    if (value != oldvalue) {
		frm = FrmGetActiveForm();
		tbl = FrmGetObjectPtr(frm,
			FrmGetObjectIndex(frm, TableFldListFields));

    		ScrollBarRecListRecordsSet(frm);
    		TblDrawTable(tbl);
    	    }
	
    	    break;

	default:
	    break;
    }

    return handled;
}

void GetFieldList(void) {
    count = 0; // TODO
}

void FreeFieldList(void) {
    // TODO
}

void ScrollBarFldListFieldsSet(FormPtr frm) {
    ScrollBarPtr	bar = FrmGetObjectPtr(frm, FrmGetObjectIndex(frm,
				ScrollBarFldListFields));
    Short		max = 0;
    
    if (count > 11) {
	max = count - 11;
    }
    SclSetScrollBar(bar, value, 0, max, 11);
}
