//
// Revalation - a simple yet flexible relational database
// Copyright (C) 2000 Mark Rigby-Jones <mrj@compsoc.net>
// http://www.compsoc.net/~mrj/palm/revalation/
// 
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//

#include <Pilot.h>
#include "revalation.h"
#include "revalationRsc.h"

/****************************************************************************
 *									    *
 *  Preferences Dialog Box						    *
 *									    *
 ****************************************************************************/

void FormPreferencesPopup(void) {
    FormPtr		frm;
    FormPtr		oldfrm;
    UInt		button;

    frm = FrmInitForm(FormPreferences);
    oldfrm = FrmGetActiveForm();

    CtlSetValue(FrmGetObjectPtr(frm,FrmGetObjectIndex(frm,
		    CheckBoxPreferencesDatabase)), prefs.deleteDatabase);
    CtlSetValue(FrmGetObjectPtr(frm, FrmGetObjectIndex(frm,
		    CheckBoxPreferencesData)), prefs.deleteData);
    CtlSetValue(FrmGetObjectPtr(frm, FrmGetObjectIndex(frm,
		    CheckBoxPreferencesTable)), prefs.deleteTable);
    CtlSetValue(FrmGetObjectPtr(frm, FrmGetObjectIndex(frm,
		    CheckBoxPreferencesAll)), prefs.deleteAll);
    CtlSetValue(FrmGetObjectPtr(frm, FrmGetObjectIndex(frm,
		    CheckBoxPreferencesRecord)), prefs.deleteRecord);
    CtlSetValue(FrmGetObjectPtr(frm, FrmGetObjectIndex(frm,
		    CheckBoxPreferencesRemember)), prefs.rememberLastView);
    
    FrmSetActiveForm(frm);
    button = FrmDoDialog(frm);
    FrmSetActiveForm(oldfrm);
   
    if (button == ButtonPreferencesOK) {
	prefs.deleteDatabase = CtlGetValue(FrmGetObjectPtr(frm,
		    FrmGetObjectIndex(frm, CheckBoxPreferencesDatabase)));
	prefs.deleteData= CtlGetValue(FrmGetObjectPtr(frm,
		    FrmGetObjectIndex(frm, CheckBoxPreferencesData)));
	prefs.deleteTable = CtlGetValue(FrmGetObjectPtr(frm,
		    FrmGetObjectIndex(frm, CheckBoxPreferencesTable)));
	prefs.deleteAll = CtlGetValue(FrmGetObjectPtr(frm,
		    FrmGetObjectIndex(frm, CheckBoxPreferencesAll)));
	prefs.deleteRecord = CtlGetValue(FrmGetObjectPtr(frm,
		    FrmGetObjectIndex(frm, CheckBoxPreferencesRecord)));
	prefs.rememberLastView = CtlGetValue(FrmGetObjectPtr(frm,
		    FrmGetObjectIndex(frm, CheckBoxPreferencesRemember)));
    }

    FrmDeleteForm(frm);
}
