//
// Revalation - a simple yet flexible relational database
// Copyright (C) 2000 Mark Rigby-Jones <mrj@compsoc.net>
// http://www.compsoc.net/~mrj/palm/revalation/
// 
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//

#include <Pilot.h>
#include "revalation.h"
#include "revalationRsc.h"

/****************************************************************************
 *									    *
 *  Rename Table Dialog Box						    *
 *									    *
 ****************************************************************************/

void FormRenameTablePopup(void) {
    Char		buf[dmCategoryLength];
    FormPtr		frm;
    FormPtr		oldfrm;
    FieldPtr		fld;
    Err			error;
    Word 		label;
    UInt		button;
    CharPtr		ptr;

    frm = FrmInitForm(FormRenameTable);
    oldfrm = FrmGetActiveForm();
    
    CategoryGetName(database, table, buf);

    fld = FrmGetObjectPtr(frm, FrmGetObjectIndex(frm, FieldRenameTableName));
    FldInsert(fld, buf, StrLen(buf));
	
    FrmSetEventHandler(frm, FormRenameTableHandleEvent);
    FrmSetActiveForm(frm);
    FrmSetFocus(frm, FrmGetObjectIndex(frm, FieldRenameTableName));
    button = FrmDoDialog(frm);
    FrmSetActiveForm(oldfrm);
   
    if (button == ButtonRenameTableOK) {
    	label = FrmGetObjectIndex(oldfrm, LabelRecListName);
	FrmHideObject(oldfrm, label);
	ptr = FrmGetLabel(oldfrm, LabelRecListName);
	CategoryGetName (database, table, ptr);
	ptr += StrLen(ptr);
	ptr[0] = '@';
	ptr++;
	error = DmDatabaseInfo(cardNo, dbID, ptr, NULL, NULL, NULL, NULL,
		    NULL, NULL, NULL, NULL, NULL, NULL);
	FrmShowObject(oldfrm, label);
    }

    FrmDeleteForm(frm);
}

Boolean FormRenameTableHandleEvent(EventPtr e) {
    Boolean		handled = false;
    FormPtr		frm;
    FieldPtr		fld;
    CharPtr		txt;
    Err			error;
    Char		buf[dmCategoryLength];
    Word		i;
    
    InsPtEnable(true);

    switch (e->eType) {
	case menuEvent:
	    MenuEraseStatus(NULL);
	    frm = FrmGetActiveForm();
	    fld = FrmGetObjectPtr(frm,
		    FrmGetObjectIndex(frm, FieldRenameTableName));

	    switch(e->data.menu.itemID) {
		case MenuItemEditUndo:
		    FldUndo(fld);
		    break;
		case MenuItemEditCopy:
		    FldCopy(fld);
		    break;
		case MenuItemEditCut:
		    FldCut(fld);
		    break;
		case MenuItemEditPaste:
		    FldPaste(fld);
		    break;
		case MenuItemEditSelect:
		    FldSetSelection(fld, 0, FldGetTextLength(fld));
		    break;
		case MenuItemEditKeyboard:
		    SysKeyboardDialog(kbdDefault);
		    break;
		case MenuItemEditGraffiti:
		    SysGraffitiReferenceDialog(referenceDefault);
		    break;
	    }

	    handled = true;
	    break;

	case ctlSelectEvent:
	    switch(e->data.ctlSelect.controlID) {
		case ButtonRenameTableOK:
		    frm = FrmGetActiveForm();
		    fld = FrmGetObjectPtr(frm,
			    FrmGetObjectIndex(frm, FieldRenameTableName));
		    txt = FldGetTextPtr(fld);
		    error = 0;
		    if ((txt == NULL) || (txt[0] == 0)) {
			error = dmErrInvalidDatabaseName;
		    } else {
			for (i = 0; i < dmRecNumCategories; i++) {
			    CategoryGetName(database, i, buf);
			    if (StrCompare(buf, txt) == 0) {
				error = dmErrAlreadyExists;
			    }
			}
		    }
		    if (error) {
			if (error == dmErrAlreadyExists) {
			    FrmCustomAlert(AlertError,
				    "A table with that name already exists.",
				    NULL, NULL);
			} else if (error == dmErrInvalidDatabaseName) {
			    FrmCustomAlert(AlertError,
				    "That is not a valid table name.",
				    NULL, NULL);
			}
			handled = true;
		    } else {
			CategorySetName(database, table, txt);
		    }
		    break;
	    }
	    break;

	default:
	    break;
    }

    return handled;
}
